; Initialize AGENDA
;
; Single task structure:
; (<taskname> <arglist>)
;
; Single fact structure:
; (<factname> <value> <arglist>)


(setq TaskList nil)
(setq CurTask  nil)
(setq FactList nil)

(defun ClearTaskList () (setq TaskList nil))
(defun ClearFactList () (setq FactList nil))

(defun AddTask (task args)
	(setq CurTask (list task args))			; change task structure here
	(setq TaskList (cons CurTask TaskList))
)

(defun TaskEq (element taskname)
	(if (eq (car element) taskname) t nil)
)

(defun RemCurTask ()
	(setq TaskList (remove CurTask TaskList))
	TaskList
)

(defun RemTask ( name )
	(foreach task TaskList
	  (if (TaskEq task name) 
		(setq TaskList (remove task TaskList)) 
		nil
	  )
	)
	TaskList
)

(defun FindFact (task)
 nil
)

(defun AddFact ( task res )
	(setq cFact (list (first task) res (second task)))
	(setq FactList (cons cFact FactList))
	(undefine cFact)
)

(defun Complete (CurTask res)
	(AddFact CurTask res)
;	(setq TaskList (remove CurTask TasList))
	res
)



(setq rule-set nil)
(setq RuleStack nil)


; the structure of rule-set element
; <rule> 
;

(defun SetRules (list)
	(setq rule-set list)
)

(defun AddRules (list)
	(setq rule-set (cons list rule-set))
	(if (null rule-set) nil
         (car rule-set))
)

(defun RemRule (rule)
	(setq rule-set (remove rule rule-set))
)

(defun RemOneRule ()
	(if (null rule-set) nil
         (setq rule-set (cdr rule-set))
	)
)

(defun NextRule ()
	(if (null rule-set) nil
	 (progn
	  (setq CurRule (car rule-set))
	  (RemOneRule)
	 )
	)
	CurRule
)


(defun PushRules ()
	(setq RuleStack (cons rule-set RuleStack))
)

(defun PopRules ()
	(setq rule-set (car RuleStack))
	(setq RuleStack (cdr RuleStack))
)

(defun CollectRules (task)
	(setq rule-set nil)
	(setq _rule-set (getchildren Rule))
	(foreach rule _rule-set
	  (if (eq (eval (FindSlot rule 'ForTask)) task)
	   (setq rule-set (cons rule rule-set))
	   nil
          )
	)
)

(defun FilterOnOff ()
	(foreach rule rule-set
	 (if (FindSlot rule 'Active)
	  (if (not (eval (FindSlot rule 'Active)))
	   (setq rule-set (remove rule rule-set))
	   nil
	  )
	  nil
	 )
	)
)

(defun FilterLeftSide ()
	(foreach rule rule-set
	  ; --- insert if translator ---
	  
	  
          (if (FindSlot rule 'IF)
	   (if (not (funcall (FindSlot rule 'IF)))
	    (setq rule-set (remove rule rule-set))
	    nil
	   )
	   nil
	  )
	)
)

(defun ArrangeRules ()
)

(defun PerformRules ()
	(foreach rule rule-set
	  (RuleProcessor rule)
	)
)



;---------------------------------------------------------------------------------------------------
;			Rule Processor
;---------------------------------------------------------------------------------------------------
(defun RuleProcessor (rule)
	(if (FindSlot rule 'THEN)
         (progn
	  (princ "   #$rule ") (princ (getname rule)) (princ "\n")
	  (funcall (FindSlot rule 'THEN) )
	 )
	 nil
	)
)

;---------------------------------------------------------------------------------------------------
;			Task Processor
;---------------------------------------------------------------------------------------------------


(defun DefaultProcessor (CurTask)
  (if (null CurTask) nil
   (progn
 

     (setq TaskHandler (eval (first CurTask)))
     (setq TaskArgs (second CurTask))
     (if (FindFact CurTask)  (RemCurTask)
      (progn
	; Try to solve
	
	(if (FindSlot TaskHandler 'CONSTRUCTOR)
	    (funcall (FindSlot TaskHandler 'CONSTRUCTOR) )
	    nil
	)

	(PushRules)
	(CollectRules (first CurTask))

	(FilterOnOff)
	(FilterLeftSide)
	(ArrangeRules)
	(PerformRules)
	(Complete CurTask nil)
	(PopRules)

      ) ;/progn
     ) ;/if fact is found        
 
   ) ;/progn 
  ) ;/if task list isn't empty
)


(defun Process ()
	(while TaskList

	  (setq CurTask (car TaskList))
	  (setq TaskList (cdr TaskList))
	  
	  (princ " #$processing ") (princ CurTask) (princ "\n")
	  (CurrentProcessor CurTask) 	  	  	

	)
	nil
)


(setf (symbol-function 'CurrentProcessor) (function DefaultProcessor))
